/***********************************************************************/
/*                                                                     */
/*  FILE        :Main.c or Main.cpp                                    */
/*  DATE        :Tue, Oct 31, 2006                                     */
/*  DESCRIPTION :Main Program                                          */
/*  CPU TYPE    :                                                      */
/*                                                                     */
/*  NOTE:THIS IS A TYPICAL EXAMPLE.                                    */
/*                                                                     */
/***********************************************************************/
//#include "typedefine.h"
#include "machine.h"
#ifdef __cplusplus
//#include <ios>                        // Remove the comment when you use ios
//_SINT ios_base::Init::init_cnt;       // Remove the comment when you use ios
#endif

void main(void);
#ifdef __cplusplus
extern "C" {
void abort(void);
}
#endif

#pragma pack

struct TXRX_USVAL
{
    unsigned    char    val_h;
    unsigned    char    val_l;
};

union
{
    struct
    {
        struct      TXRX_USVAL  SPEED;
        struct      TXRX_USVAL  RPM;
        struct      TXRX_USVAL  NE;
        unsigned    char        SIG1;
        unsigned    char        SIG2;
    }SIG;
    struct
    {
        unsigned    char    DATA[8];
    }BYTE;
}TXRX;

#pragma packoption

#define TXRX_GET_SPEED(txrx)\
    ((unsigned short)((txrx.SIG.SPEED.val_h << 8) | txrx.SIG.SPEED.val_l))

#define TXRX_SET_SPEED(txrx, speed)\
    do{\
        txrx.SIG.SPEED.val_h = (unsigned char)(speed >> 8);\
        txrx.SIG.SPEED.val_l = (unsigned char)speed;\
    }while(0)

volatile unsigned short debug_val;

void main(void)
{
    TXRX.BYTE.DATA[0] = 0x12;
    TXRX.BYTE.DATA[1] = 0x34;
    TXRX.BYTE.DATA[2] = 0x56;
    TXRX.BYTE.DATA[3] = 0x78;
    TXRX.BYTE.DATA[4] = 0x9A;
    TXRX.BYTE.DATA[5] = 0xBB;
    TXRX.BYTE.DATA[6] = 0xCC;
    TXRX.BYTE.DATA[7] = 0xDD;

    debug_val = TXRX_GET_SPEED(TXRX);
    nop(); /* for debug breakpoint */

    TXRX_SET_SPEED(TXRX, 0xABCD);
    nop(); /* for debug breakpoint */

    debug_val = TXRX_GET_SPEED(TXRX);
    nop(); /* for debug breakpoint */

    while (1)
    {
        ;
    }
}

#ifdef __cplusplus
void abort(void)
{

}
#endif
